/*

Scrivere un programma per la gestione delle iscrizioni ad un'associazione sportiva e delle prenotazioni alle attivit su base settimanale.
Gli iscritti sono caratterizzati da: codice fiscale, et e tipo di iscritto (0=ragazzi, 1=adulti, 2=over 65 anni).
Le prenotazioni sono caratterizzate da: codice fiscale, codice attivit, giorno della settimana (lun=0,.., sab=5). 
Gli iscritti sono inseriti in un vettore di 3 liste,  una per ogni tipo di iscritto. 
Le prenotazioni sono inserite in una tabella allocata dinamicamente avente 6 righe, una  per ogni giorno feriale della settimana.

Nel programma  presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento  nel vettore di liste di un nuovo iscritto; 
2.	Ricerca di un iscritto;
3.	Inserimento ordinato rispetto al codice fiscale di una nuova prenotazione;
4.	Visualizzazione delle prenotazioni relative a un certo giorno della settimana;
5.	Salvataggio su file delle prenotazioni;

All'avvio del programma inizializzare la tabella delle prenotazioni leggendo da file le prenotazioni precedentemente salvate.

Liberare la memoria allocata dinamicamente.

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct prenotazione {
       char cod_fisc[16];
       int codice;
       int giorno;
};

struct iscritto {
       char cod_fisc[16];
       int eta;
       int tipo; 
       };
       
struct atomo {
       struct iscritto dato;
       struct atomo*next; 
       };

void inizializza(struct prenotazione *T[6], int *N);
void ins_iscritto(struct atomo *L[3]);
void ricerca_iscritto(struct atomo *L[3]);
void leggi_prenotazione(struct prenotazione *a);
void ins_ordinato(struct prenotazione *T[6],int *N, struct prenotazione a);
void vis_prenotazione(struct prenotazione *T[6],int *N);
void salva(struct prenotazione *T[6],int N[6]);
void da_testa(struct atomo **ptl);
 
main()
{
      struct atomo *L[3],*a;
      struct iscritto p;
      struct prenotazione *T[6],pr;
      int N[6],scelta,i;
      
      for(i=0;i<3;i++)
           L[i]=NULL;
      for(i=0;i<6;i++)
      {
          T[i]=NULL;
          N[i]=0;
      }
      
      inizializza(T,N);

     do{
         printf("\nScegli tra: \n");
         printf("1)Inserisci una nuovo iscritto\n");
         printf("2)Ricerca iscritto\n");
         printf("3)Inserisci una nuova prenotazione\n");
         printf("4)Visualizza prenotazione\n");
         printf("5)Salva su file le prenotazioni\n");
         printf("0)Termina programma;\n");
         scanf("%d",&scelta);
         switch(scelta)
         {
                       case 1: ins_iscritto(L);
                               break;
                       case 2: ricerca_iscritto(L);
                               break;
                       case 3: leggi_prenotazione(&pr);
                               ins_ordinato(T,N,pr);
                               break;
                       case 4: vis_prenotazione(T,N);
                               break;
                       case 5: salva(T,N);
                               break;
         }
         }while(scelta!=0);
        
         for(i=0;i<3;i++)
            while(L[i]!=NULL)
              { a=L[i];
                L[i]=a->next;
                free(a);
              }
              
         for(i=0;i<6;i++)
         free(T[i]);
}



void ins_iscritto(struct atomo *L[3]){               
     struct atomo *aux;                         
     struct iscritto d;
     int tipo;
     
     printf("- Codice fiscale: ");
     scanf("%s",d.cod_fisc);
     printf("- Eta': ");
     scanf("%d",&d.eta);
     printf("- Tipo di iscritto (0...2): ");
     scanf("%d",&d.tipo);
      
     aux=malloc(sizeof(struct atomo));
     if(aux==NULL){
         printf("Memoria non allocata!\n");
         return;
     }
     tipo=d.tipo;
     aux->dato=d;
     aux->next=L[tipo];
     L[tipo]=aux;
}

void ricerca_iscritto(struct atomo *L[3]){                  
     int tipo;
     char cod_fisc[17];                              
     struct atomo *aux;
     
     printf("- Inserisci tipo di iscritto (0...2): ");
     scanf("%d",&tipo);

           if(L[tipo]==NULL){    
                printf("Nessun iscritto di questo tipo\n");
                return;
           }
              
           printf("Codice fiscale: ");
           scanf("%s",cod_fisc);
           aux=L[tipo];
           while(aux!=NULL)
              if(strcmp(cod_fisc,aux->dato.cod_fisc)==0){      
                    printf("- Eta': %d\n",aux->dato.eta);
                    return;
                 }
              else aux=aux->next;
              
           printf("Non trovato!\n");      
}            

void leggi_prenotazione(struct prenotazione *a){                          
     printf("Codice fiscale: ");     
     scanf("%s",a->cod_fisc);                             
     printf("Codice attivita': ");
     scanf("%d",&a->codice);
     printf("Giorno della settimana (0...5): ");
     scanf("%d",&a->giorno);
}
void ins_ordinato(struct prenotazione *T[6],int *N, struct prenotazione a){
        int i,j,t;
        struct prenotazione *p;
               
        t=a.giorno;
        p=realloc(T[t],sizeof(struct prenotazione)*(N[t]+1));
        if(p==NULL) return;
        T[t]=p;
        
        for(i=0;i<N[t];i++)
         if(a.codice<T[t][i].codice)
             break;
                
        N[t]++;
        for(j=N[t]-1;j>i;j--)
            T[t][j]=T[t][j-1];
        T[t][i]=a;
}

void vis_prenotazione(struct prenotazione *T[6],int *N){                  
    int i,j;                                             
    int giorno;
     
    printf("Giorno:\n ");
    scanf("%d",&giorno);
    
    for(j=0;j<N[giorno];j++)                
       { 
          printf("Codice fiscale: %s\n",T[giorno][j].cod_fisc);
          printf("Codice attivita': %d\n",T[giorno][j].codice);  
       }
}

void salva(struct prenotazione *T[6],int N[6]){
 	 FILE *pf;
 	 int i,j;
     
     pf=fopen("prenotazioni.txt","w");
     if(pf)
       {for(i=0;i<6;i++)
            fwrite(T[i],sizeof(struct prenotazione),N[i],pf);
        fclose(pf);
       }
     else printf("Errore in scrittura file");
}

void inizializza(struct prenotazione *T[6], int *N){
     int giorno;
     struct prenotazione a;
     struct prenotazione *aux;
     FILE *pf;
     
     pf=fopen("prenotazioni.txt","r");
     if(pf){  
             while(fread(&a,sizeof(struct prenotazione),1,pf))
              ins_ordinato(T,N,a);
              
             fclose(pf);
           } 
     else printf("\n Il file non e' stato creato!!\n");
}
