/*
Scrivere un programma per la gestione dei dipendenti di una societ e delle attivit di ciascun dipendente . 
I dipendenti sono caratterizzati dalle seguenti informazioni: cognome, nome, matricola, tipo di mansione.
Ogni attivit di un dipendente  caratterizzata dalle seguenti informazioni: matricola dipendente, codice attivit, giorno della settimana in cui deve essere svolta l'attivit (0=lun, 1=mar, 4=ven). 
I dipendenti sono inseriti in un vettore di 6 liste, una per ogni tipo di mansione. 
Le attivit sono inserite in una tabella allocata dinamicamente avente 5 righe, una  per giorno della settimana.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento ordinato rispetto alla matricola nel vettore di liste di una nuovo dipendente; 
2. Ricerca di un dipendente;
3. Inserimento di una nuova attivit;
4. Visualizzazione di tutte le attivit relative a un certo giorno della settimana;
5. Salvataggio su file delle attivit dei dipendenti;
6. Lettura da file delle attivit di un solo dipendente precedentemente salvate e inserimento in tabella;

Liberare la memoria allocata dinamicamente.



*/


#include <stdio.h>
#include <stdlib.h>

struct dipendente{
       char cognome[20], nome[20];
       int matricola, tipo;};
       
struct atomo{
       struct dipendente dato;
       struct atomo *next;
       };
       
struct attivita{
       int matricola, codice, giorno;
       };

void da_testa(struct atomo **tl);
void leggi_dipendente(struct dipendente *d);
void in_lista(struct atomo *L[4]);
void ricerca(struct atomo *L[6]);
void leggi_attivita(struct attivita *a);
void in_tabella(struct attivita *T[5], int *N);
void vis_attivita(struct attivita *T[5], int *N);
void salva(struct attivita *T[5], int *N);
void carica(struct attivita *T[5], int *N);

main()
{
  struct attivita *T[5];
  struct atomo *L[6];
  int i , scelta , N[5];
 
  for(i=0;i<5;i++)
   {
    T[i]=NULL;
    N[i]=0;
   }
   
  for(i=0;i<6;i++)
    L[i]=NULL;

   do{
      printf("MENU'\n");
      printf("1)Inserisci nuovo dipendente\n");
      printf("2)Ricerca dipendente\n");
      printf("3)Inserisci attivita'\n");
      printf("4)Visualizza attivita'\n");
      printf("5)Salva attivita'\n");
      printf("6)Carica attivita' relative un dipendente\n");
      printf("Scegli un opzione\n");
      scanf("%d",&scelta);
      switch(scelta)
      {
               case 1: in_lista(L);
               break;
               case 2: ricerca(L);
               break;
               case 3: in_tabella(T,N);
               break;
               case 4: vis_attivita(T,N);
               break;
               case 5: salva(T,N);
               break;
               case 6: carica(T,N);
               break;
               default: ;
               }}while(scelta!=0);
 
 for(i=0;i<5;i++)
    free(T[i]);
    
 for(i=0;i<6;i++)
   while(L[i]!=NULL)
      da_testa(&L[i]);
}

void da_testa(struct atomo **tl)
{
  struct atomo *a;

   a=*tl;
   *tl=a->next;
   free(a);
}

void leggi_dipendente(struct dipendente *d)
{
  printf("Nome\n");
  scanf("%s",d->nome);
  printf("Cognome\n");
  scanf("%s",d->cognome);
  printf("Matricola\n");
  scanf("%d",&d->matricola);
  printf("Tipo mansione 0,1,2,3,4,5 \n");
  scanf("%d",&d->tipo);
}


void in_lista(struct  atomo *L[4])
{
 struct atomo *a, *l1, *l2;
 int i;
 struct dipendente d;

 leggi_dipendente(&d);
 i=d.tipo;
 a=malloc(sizeof(struct atomo));
 
 if(a==NULL)
 {
   printf("Impossibile allocare memoria\n");
   return;
 }
 
 a->dato=d;
 if(L[i]==NULL||d.matricola<L[i]->dato.matricola)
 {
  a->next=L[i];
  L[i]=a;
  return;
 }
 
 l2=L[i];
 l1=l2->next;
 while(l1)
    if(d.matricola<l1->dato.matricola)
       break;
    else
        { 
         l2=l1;
         l1=l1->next;
        }
 l2->next=a;
 a->next=l1;
}

void ricerca(struct atomo *L[4])
{
 struct atomo *l1;
 int i,matricola;
 
 printf("Tipo mansione svolta dal dipendente 0, 1, 2, 3, 4, 5\n");
 scanf("%d",&i);

 if(L[i]==NULL)
 {
  printf("Non presente\n");
  return;
 }
 
 printf("Matricola dipendente\n");
 scanf("%d",&matricola);

 l1=L[i];
 while(l1)
   if(matricola==l1->dato.matricola)
     {
      printf("Nome %s\n",l1->dato.nome);
      printf("Cognome %s\n\n",l1->dato.cognome);
      return;
     }
   else
       l1=l1->next;
 
 printf("Non presente\n");
}

void leggi_attivita(struct attivita *a)
{
 printf("Matricola dipendente\n");
 scanf("%d",&a->matricola);
 printf("Codice attivita\n");
 scanf("%d",&a->codice);
 printf("Giorno 0=lunedi, 1=martedi, 2=mercoledi, 3=giovedi, 4=venerdi\n");
 scanf("%d",&a->giorno);
}

void in_tabella(struct attivita *T[5], int *N)
{
 struct attivita a,*R;
 int i;
 
 leggi_attivita(&a);
 i=a.giorno;
 R=realloc(T[i], sizeof(struct attivita)*(N[i]+1));
 if(R==NULL)
 {
  printf("Impossibile allocare memoria\n");
  return;
 }
 
 T[i]=R;
 T[i][N[i]]=a;
 N[i]++;
}

void vis_attivita(struct attivita *T[5], int *N)
{
 int i,j;
 
 printf("Visualizzare le attivita relative al giorno? 0,1,2,3,4\n");
 scanf("%d",&i);
 
 for(j=0;j<N[i];j++)
 {
  printf("Matricola dipendente: %d\n",T[i][j].matricola);
  printf("Codice attivita:  %d\n\n",T[i][j].codice);
 }
}

void salva(struct attivita *T[5], int *N)
{
 FILE *pf;
 int i;

 pf=fopen("attivita.txt", "w");
 if(pf==NULL)
 {
  printf("Memoria piena\n");
  return;
 }
 
 for(i=0;i<5;i++)
  fwrite(T[i],sizeof(struct attivita),N[i], pf);
 fclose(pf);
}


void carica(struct attivita *T[5], int *N)
{
 FILE *pf;
 int i, matricola,j;
 struct attivita a, *R;

 printf("Matricola dipendente di cui si devono caricare le attivita\n");
 scanf("%d",&matricola);
 
 pf=fopen("attivita.txt","r");
 if(pf)
 {
  while(fread(&a,sizeof(struct attivita), 1,  pf)>0)
   if(matricola==a.matricola)
    {
      i=a.giorno;
      R=realloc(T[i],sizeof(struct attivita)*(N[i]+1));
      if(R==NULL)
      {
       printf("Impossibile\n");
       return;
      }
      
     T[i]=R;
     T[i][N[i]]=a;
     N[i]++;
    }
   fclose(pf);
  }
 else("Nessuna dato precedentemente salvato\n");

}
