/*
Scrivere un programma per la gestione delle automobili in car sharing e della loro prenotazioni. 
Le automobili sono caratterizzate da: targa, anno, categoria (0..5)
Le prenotazioni sono caratterizzate da: codice fiscale, data, ora, categoria automobile (0..5).
Le automobili sono inserite in una tabella allocata dinamicamente avente 6 righe, una per ogni  categoria.
Le prenotazioni sono inserite in un vettore di 6 liste, una per ogni categoria. 


Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento di una nuova automobile;
2.	Eliminazione dell'ultima automobile inserita di una cerca categoria dopo averla visualizzata ( chiedere la categoria);
3.	Inserimento  ordinato rispetto al codice fiscale nel vettore di liste di una nuova prenotazione; 
4.	Visualizzazione delle prenotazioni antecedenti a una certa data;
5.	Salvataggio su file delle automobili;

All'avvio del programma inizializzare la tabella delle automobili leggendo da file le automobili  precedentemente salvate.

Al termine dell'esecuzione del programma liberare la memoria allocata dinamicamente.


*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct automobile {
       char targa[7];
       int anno;
       int categoria;
};

struct prenotazione {
       char cod_fisc[16];
       char data[10];
       int ora;
       int categoria; 
       };
       
struct atomo {
       struct prenotazione dato;
       struct atomo*next; 
       };
       
void leggi_automobile(struct automobile *t);
void inserisci_automobile(struct automobile **T,int *n,struct automobile t);
void elimina_automobile(struct automobile *T[6], int *N);
       
void leggi_prenotazione(struct prenotazione *p);
void inserisci_prenotazione(struct atomo **L, struct prenotazione p);
void visualizza_prenotazioni(struct atomo *L[6]);
void salva_su_file(struct automobile *T[6],int N[6]);
void inizializza(struct automobile *T[6],int N[6]);
void da_testa(struct atomo **ptl);

main()
{
      struct atomo *L[6];
      struct prenotazione p;
      
      struct automobile *TA[6],t;
      int N[6],scelta,i;
      
      /*inizializzazione */
      for(i=0;i<6;i++)
           L[i]=NULL;
      for(i=0;i<6;i++)
      {
          TA[i]=NULL;
          N[i]=0;
      }
      
      inizializza(TA,N);
      
      do{
         printf("\n\n-----MENU'-----\n\n");
         printf("Scegli tra: \n");
         printf("1)Inserisci una nuova automobile;\n");
         printf("2)Elimina l'ultima automobile inserita;\n");
         printf("3)Inserisci una nuova prenotazione;\n");
         printf("4)Visualizza le prenotazioni antecedenti a una certa data;\n");
         printf("5)Salva su file l' automobile;\n");
         printf("0)Termina programma;\n");
         scanf("%d",&scelta);
         switch(scelta)
         {
                       case 1: leggi_automobile(&t);
                               i=t.categoria;
                               inserisci_automobile(&TA[i],&N[i],t);
                               break;
                       case 2: elimina_automobile(TA,N);
                               break;
                       case 3: leggi_prenotazione(&p);
                               i=p.categoria;
                               inserisci_prenotazione(&L[i],p);
                               break;
                       case 4: visualizza_prenotazioni(L);
                               break;
                       
                       case 5: salva_su_file(TA,N);
                               break;
         }
         }while(scelta!=0);
        
        /* Liberazione della memoria allocata dinamicamente */
        
         for(i=0;i<6;i++)
            while(L[i]!=NULL)
              da_testa(&L[i]);
              
         for(i=0;i<6;i++)
         free(TA[i]);
}



void leggi_automobile(struct automobile *t)
{ 
     printf("Targa: \n");
     scanf("%s", t->targa);
     printf("Anno: \n");
     scanf("%d", &t->anno);
     printf("Categoria: \n");
     scanf("%d", &t->categoria); }
     

void inserisci_automobile(struct automobile **T,int *n,struct automobile t)
{
     struct automobile *a;
     a=realloc(*T,(*n+1)*sizeof(struct automobile));
     if(a==NULL)
        return;
     
     *T=a;
     /* inserimento in ultima posizione */
     (*T)[*n]=t;
     (*n)++; }
     
     
void elimina_automobile(struct automobile *T[6], int *N)
{
     int i, j, categoria;
     
     printf("Inserisci categoria automobile: \n");
     scanf("%d",&categoria);

     /* visualizziamo l'ultimo elemento inserito 
        ovvero l'elemento in ultima posizione */
      printf("Targa: %s\n",T[categoria][N[categoria]-1].targa);
      printf("Anno: %d\n",T[categoria][N[categoria]-1].anno);
        
     /* eliminiamo l'ultimo elemento */     
     N[categoria]--;
     T[categoria]=realloc(T[categoria],sizeof(struct automobile)*(N[categoria]));
}



void leggi_prenotazione(struct prenotazione *p)
{
     printf("Codice fiscale: \n");
     scanf("%s", p->cod_fisc);
     printf("Data: \n");
     scanf("%s", p->data);
     printf("Ora: \n");
     scanf("%d", &p->ora);
     printf("Categoria: \n");
     scanf("%d", &p->categoria); }
     
void inserisci_prenotazione(struct atomo **L, struct prenotazione p)
{ struct atomo *a, *l1, *l2;
  int i;
  
  a=malloc(sizeof(struct atomo));
  if(a==NULL)
  return;
  
  a->dato=p;
  if(*L==NULL || strcmp(p.cod_fisc,(*L)->dato.cod_fisc)<0)
    /* inserimento in testa */
   { 
    
     a->next=*L;
     *L=a;
     return;
   }
  /* inserimento in posizione successiva alla prima */ 
  l2=*L;
  l1=l2->next;
  while(l1)
   if(strcmp(p.cod_fisc,l1->dato.cod_fisc)<0)
        break;
   else { 
         l2=l1;
         l1=l1->next;
        }
        
  a->next=l1;
  l2->next=a; 
}

void visualizza_prenotazioni(struct atomo *L[6])
{
     int i;
     char datavis[10];
     struct atomo *p;
     
     printf("Data: ");
     scanf("%s",datavis);
     /* visualizzo per tutte le liste gli elementi con data minore di datavis  */
     
     for(i=0;i<6;i++)
       { p=L[i];
         while(p!=NULL)
           { if(strcmp(p->dato.data,datavis)<0)
               { 
                    printf("Codice fiscale: %s\n", p->dato.cod_fisc);
                    printf("Data: %s\n", p->dato.data);
                    printf("Ora: %d\n", p->dato.ora);
                    printf("Categoria: %d\n", p->dato.categoria);
               }
             
             p=p->next; 
           }
        }
} 
                    
                    
void salva_su_file(struct automobile *T[6],int N[6])
{
     FILE *pf;
     int i, tipo;
     int categoria;
     
     pf=fopen("automobili.txt", "w");
     if(pf!=NULL)
      {for(tipo=0;tipo<6;tipo++)
         fwrite(T[tipo],sizeof(struct automobile),N[tipo],pf);
     
       fclose(pf);
      }
     else printf("Errore in scrittura\n"); 
}

      
void inizializza(struct automobile *T[6],int N[6])
{
     FILE *pf;
     struct automobile temp;
     int i;
     pf=fopen("automobili.txt","r");
     if(pf!=NULL)
     {
                 while(fread(&temp,sizeof(struct automobile),1,pf)>0)
                 {
                    i=temp.categoria;
                    inserisci_automobile(&T[i],&N[i],temp);
                 }
                 
                 fclose(pf);
     }
     else printf("Errore: il file non esiste\n");
}

void da_testa(struct atomo **ptl)
{ struct atomo *a;
  
  a=*ptl;
  *ptl=a->next;
  free(a); 
}
